---
# file: tests/2.test_simplest_set.yml

- name: "MOUNTS | TEST-2 | run test with minimal set of defined options"

  hosts: all
  gather_facts: True

  vars:
    mounts_list:
      # Path to the mount point (e.g. /mnt/files).
    - path: /mnt/TEST_1
      # Device to be mounted on path. Required when state set to 'present' or 'mounted'.
      src: //localhost/test_1
      # 'mounted' - the device will be actively mounted and appropriately configured in fstab. If the mount point is
      # not present, the mount point will be created.
      # 'unmounted' - the device will be unmounted without changing fstab.
      # 'present' - only specifies that the device is to be configured in fstab and does not trigger or require
      # a mount.
      # 'absent' - specifies that the device mount's entry will be removed from fstab and will also unmount the device
      # and remove the mount point.
      state: present
      # Filesystem type. Required when state is present or mounted.
      fstype: cifs
      # Mount options (see fstab(5), or vfstab(4) on Solaris).
      opts: 'vers=2.1,nofail,x-systemd.automount,x-systemd.requires=network-online.target,x-systemd.device-timeout=30s,cache=none,rsize=130048,wsize=131007,dir_mode=0775,file_mode=0664'
      # Create a backup file including the timestamp information so you can get the original file back if you somehow
      # clobbered it incorrectly.
      backup: False

  pre_tasks:
    - name: "***[ OPERATING SYSTEM ]***"
      debug:
        msg: "{{ item }}"
      with_items:
        - "OS:                  {{ ansible_os_family|default('undefined') }}"
        - "Distribution:        {{ ansible_distribution|default('undefined') }}"
        - "Release:             {{ ansible_distribution_release|default('undefined') }}"
        - "Version:             {{ ansible_distribution_version|default('undefined') }}"
        - "Virtualization Role: {{ ansible_virtualization_role|default('undefined') }}"
        - "Virtualization Type: {{ ansible_virtualization_type|default('undefined') }}"
        - "Python version:      {{ ansible_python_version|default('undefined') }}"
    - name: "***[ PLAY VARIABLES ]***"
      debug:
        msg: "{{ item }}"
      with_items:
        - "mounts_list: {{ mounts_list }}"

  roles:
    - role_is_being_tested

  post_tasks:
    - name: "***[ CHECK ROLE RESULT ]***"
      shell:
        "cat /etc/fstab"
      register: role_execution_check
      changed_when: False
      failed_when:
        - role_execution_check.stdout is not defined or role_execution_check.stdout|length == 0
        - role_execution_check.stderr is not defined or role_execution_check.stderr|length == 0
    - name: "***[ DEBUG OUTPUT ]***"
      debug:
        msg: "{{ role_execution_check.stdout_lines + role_execution_check.stderr_lines }}"
      failed_when:
        - not (role_execution_check.stdout is search(mounts_list[0]['path']))
